{

 CHRISTIAN FERON  


  Information        :  *******  TChrisUpFreeColorGrid  *******
  Type               :           Freeware
  Software Name :    :           Christian Feron Free Color Grid
  Homepage           :
  Auteur             :           Christian Feron
  E-mail             :           chrisferon@free.fr
  Delphi             :           Delphi 4
  Date 		     :		 May 1st, 2003

  Features :
  - ColorGrid looks like Win95, SIZEABLE.
  - 16 colors + 2 control-cell in a bevel.
  - horizontal and vertical position.
  - BevelInner and BevelOuter properties.
  - Tested with Delphi 4.




  This component is based on RogerColorGrid 1.0, 20/12/2000, Rogerio Olimpio
  Loureno de Oliveira, homepage http://rogersoft.zzn.com, e-mail :  Rogerio.
  olimpio@rogersoft.zzn.com.
  Special thanks and my best regards for him, and for his work for his free VCL
  Component RogerColorGrid.

  Chris Up Free Color Grid is a new free contribution for everyone who like
  programming.
  Follow this example for everyone who need tools and don't have enough 
  chance to can buy them, if it is possible for you.
  Enjoy !



}

unit ChrisUpFreeColorGrid;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls;

type
    TDirection=(poHorizontal,poVertical);
type
  TChrisUpFreeColorGrid = class(TCustomPanel)
  private
    { Private declarations }
      FFCor: TColor;
      FBCor: TColor;
      Fpos: TDirection;
      FHTMLfCor: ShortString;
      FHTMLbCor: ShortString;
      FOnColorChange: TNotifyEvent;
      procedure DrawGrid(Dir: TDirection);
      procedure SetFFCor(Cor: TColor);
      procedure SetFBCor(Cor: TColor);
      procedure ColorChange;
  protected
    { Protected declarations }
      Function WebColor(Cor:TColor): String;
  public
    { Public declarations }
    constructor Create(AComponent: TComponent); override;
    procedure resize; override;
  published
    { Published declarations }
    property BackColor: TColor read FbCor write SetFbCor default clWhite;
    property BevelInner; //New Feature
    property BevelOuter; //New feature
    property Color;
    property Ctl3D;
    property ForeColor: TColor read FfCor write SetFFCor default clBlack;
    property Position: TDirection read FPos write DrawGrid default poHorizontal;
    procedure ShapeClick(Sender: TObject; Button: TMouseButton;Shift:
                         TShiftState; X, Y: Integer);
    property HTMLForeColor : shortString read FHTMLfCor;
    property HTMLBackColor : shortString read FHTMLbCor;
    property OnColorChange : TNotifyevent read FOnColorChange write FOnColorChange;
    property Enabled;
    property FullRepaint;
    property Locked;
    property ParentColor;
    property ParentCtl3D;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property TabOrder;
    property TabStop;
    property Visible;
    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnEnter;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property Top;
    property Left;
  end;

procedure Register;

implementation

const
  Color16: array [0..15] of TColor = (
  clBlack, clMaroon, clGreen, clOlive, clNavy, clPurple, clTeal, clGray,
    clSilver, clRed, clLime, clYellow, clBlue, clFuchsia, clAqua, clWhite
);

Function TChrisUpFreeColorGrid.WebColor(Cor:TColor): String;
var
     Temp : Integer;
     Temp2: String;
begin
     temp := ColorToRGB(Cor);
     Temp2 := IntToHex(temp,6);
     Result := '#'+Copy(Temp2,5,2)+Copy(Temp2,3,2)+Copy(Temp2,1,2);
end;

constructor TChrisUpFreeColorGrid.Create(AComponent: TComponent);
begin
   inherited Create(AComponent);
   Caption := ' ';
   Width := 200 ;
   Height := 40 ;
   FfCor:= clBlack ;
   fbcor:= clWhite ;
   DrawGrid(poHorizontal);
end;

procedure TChrisUpFreeColorGrid.SetFFCor(Cor: TColor);
begin
if ffcor<>cor then
begin
     Ffcor:=cor;
     TShape(FindComponent('SFcor')).brush.color:=ffcor;
     FHTMLfCor:= webcolor(ffcor);
     colorchange;
end;
end;

procedure TChrisUpFreeColorGrid.SetFBCor(Cor: TColor);
begin
if fbcor<>cor then
begin
     Fbcor:=cor;
     TShape(FindComponent('SBcor')).brush.color:=fbcor;
     FHTMLbCor:= webcolor(fbcor);
     colorchange;
end;
end;

procedure TChrisUpFreeColorGrid.DrawGrid(Dir: TDirection);
var
   x: TShape;
   y: TBevel;
   a,b: integer ;
   c1,c2 : real;
   QCor: Byte ;
   bor, eclh, eclv, echh, echv, lch, hch,lcv, hcv : real ;
   controle: TControl;
   NombreRangs, NombreCases,
   EyeCaseLargeurHorizontale, EyeCaseLargeurVerticale,
   EyeCaseHauteurHorizontale, EyeCaseHauteurVerticale,
   LargeurTotale, HauteurTotale,
   LargeurCaseHorizontale, HauteurCaseHorizontale, LargeurCaseVerticale,
   HauteurCaseVerticale,
   LargeurRestanteHorizontale, HauteurRestanteHorizontale,
   LargeurRestanteVerticale, HauteurRestanteVerticale,
   Bordure : real ;
begin
FPos := Dir ;
while ControlCount > 0 do
   begin
     controle:=Controls[0];
     removecontrol(controle);
     controle.destroy;
     end;
//*************** CONTROL CENTER **********************************************
     LargeurTotale := Width; //Panel Width
     HauteurTotale := Height;  //Panel Height
//Number of columns ad Cells :
     NombreRangs := 1; //Is columns number - 1
     NombreCases := 7;  //Is cells number in only one column - 1
//EyeCase, free space for bevel :
     EyeCaseLargeurHorizontale := LargeurTotale / 5; //5e of Width
     EyeCaseHauteurHorizontale := HauteurTotale ;
     EyeCaseLargeurVerticale := LargeurTotale;
     EyeCaseHauteurVerticale := HauteurTotale / 5; //5e of Height
//Border :
     Bordure := (Width + Height) / 80; //80 % of Height
//Width and height for color-cells :
    LargeurRestanteHorizontale := LargeurTotale - (EyeCaseLargeurHorizontale +
                                        (Bordure * 2)) ;
    HauteurRestanteHorizontale := (HauteurTotale - (Bordure * 2)) - 2 ;
    LargeurRestanteVerticale := (LargeurTotale - (Bordure * 2)) + 1 ;
    HauteurRestanteVerticale := HauteurTotale - (EyeCaseHauteurVerticale +
                                        (Bordure * 2)) ;
//Width and height of color-cells :
   LargeurCaseHorizontale := (LargeurRestanteHorizontale / (NombreCases + 1));
   HauteurCaseHorizontale := HauteurRestanteHorizontale / (NombreRangs + 1) ;
   LargeurCaseVerticale := LargeurRestanteVerticale / (NombreRangs + 1) ;
   HauteurCaseVerticale := HauteurRestanteVerticale / (NombreCases + 1) ;
//*****************************************************************************

if Dir = poHorizontal then //If color-panel is horizontal :
begin
     c1:= NombreRangs ;
     c2:= NombreCases ;
     hch := HauteurCaseHorizontale ;
     lch := LargeurCaseHorizontale - 2 ;
     hcv := 0 ;
     lcv := 0 ;
     eclh:= EyeCaseLargeurHorizontale ;
     echh := EyeCaseHauteurHorizontale;
     eclv := 0 ;
     echv := 0 ;
     bor := Bordure ;
end
else    //If color-panel is vertical :
begin
     c1:= NombreCases ;
     c2:= NombreRangs ;
     hch := 0 ;
     lch := 0 ;
     hcv := HauteurCaseVerticale - 2 ;
     lcv := LargeurCaseVerticale - 2 ;
     eclh:= 0 ;
     echh := 0 ;
     eclv := EyeCaseLargeurVerticale ;
     echv := EyeCaseHauteurVerticale ;
     bor := Bordure ;
end;

Width := Round(LargeurTotale) ;
Height := Round(HauteurTotale) ;
QCor :=0 ;
for a := 0 to Round(C1) do
    begin
         for b := 0 to Round(C2) do
             begin
                  x := TShape.Create(self);
                  x.height := Round(hch + hcv);
                  x.width := Round(lch + lcv) ;
                  x.left := Round(bor + eclh + (b *((lch + 1) + (lcv + 1)))) ;
                  x.top := Round(bor + echv + (a *((hch + 1) + (hcv + 1)))) ;
                  x.Brush.color := Color16[Qcor] ;
                  x.OnMouseDown := ShapeClick ;
                  InsertControl(x);
                  inc(QCor);
    end;

end;
// ******* Eyes Control Color *****
try
y:=TBevel.Create(self);
y.height:= Round((echh + echv) - (bor * 2)) ;
y.width:= Round((eclh + eclv) - (bor * 2)) ;
y.left:= Round(bor) ;
y.top:= Round(bor) ;
insertControl(y);

//BackGround Cell. To draw BEFORE the Foreground Cell.
x:=TShape.Create(self);
x.height := Round((echh + echv) - (bor * 7)) ;
x.width := Round((eclh + eclv)- (bor * 7)) ;
x.left := Round(bor * 5) ;
x.top := Round(bor * 5) ;
x.name := 'SBCor' ;
x.Brush.color :=clWhite;
InsertControl(x);

//ForeGround Cell. To draw AFTER the Background Cell.
x:=TShape.Create(self);
x.height := Round((echh + echv) - (bor * 7));
x.width := Round((eclh + eclv) - (bor * 7));
x.left := Round(bor * 2) ;
x.top := Round(bor * 2) ;
x.name := 'SFCor';
x.Brush.color := clBlack ;
InsertControl(x);

except
end;
end;

procedure TChrisUpFreeColorGrid.ShapeClick(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
if ssleft in shift then
begin
   if ffcor<>TShape(sender).brush.color then
   begin
     ffcor:=TShape(sender).brush.color;
     TShape(FindComponent('SFcor')).brush.color:=ffcor;
     FHTMLfCor:= webcolor(ffcor);
     colorchange;
   end
end
else
begin
   if fbcor<>TShape(sender).brush.color then
   begin
     fbcor:=TShape(sender).brush.color;
     TShape(FindComponent('SBcor')).brush.color:=fbcor;
     FHTMLbCor:= webcolor(fbcor);
     colorchange;
   end
end;
end;

procedure TChrisUpFreeColorGrid.resize;
begin
     DrawGrid(Fpos);
     inherited;
end;

procedure TChrisUpFreeColorGrid.ColorChange;
begin
if assigned(FOnColorChange) then
   FOnColorChange(self);
end;

procedure Register;
begin
  RegisterComponents('Chris UP !', [TChrisUpFreeColorGrid]);
end;

end.
